/*
 * JBoss, Home of Professional Open Source
 * Copyright 2009, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2009
 * @author JBoss Inc.
 */
package org.jboss.jbossts.rts.demo.client.service;

import com.google.gwt.core.client.JavaScriptObject;

class BookingData extends JavaScriptObject {
	// Overlay types always have protected, zero argument constructors.
	protected BookingData() {}

	// JSNI methods to retrieve booking data.
	public final native String getService() /*-{ return this.service; }-*/;
	public final native String getPeople() /*-{ return this.people; }-*/;
	public final native String getDiners() /*-{ return this.diners; }-*/;
	public final native String getSeats() /*-{ return this.seats; }-*/;
	public final native String getSeatType() /*-{ return this.seatType; }-*/;
	public final native String getTaxi() /*-{ return this.taxi; }-*/;
	public final native String getTxId() /*-{ return this.txId; }-*/;
	public final native String getStatus() /*-{ return this.status; }-*/;

	// update UI
	public final void updateWidgets(java.util.Map<String, WidgetBinding> widgets)
	{
		if (widgets.containsKey("seatType"))
			widgets.get("seatType").setValue(getSeatType());
		if (widgets.containsKey("seats"))
			widgets.get("seats").setValue(getSeats());
		if (widgets.containsKey("people"))
			widgets.get("people").setValue(getPeople());
		if (widgets.containsKey("taxi"))
			widgets.get("taxi").setValue(getTaxi());
		if (widgets.containsKey("txId"))
			widgets.get("txId").setValue(getTxId());
		if (widgets.containsKey("status"))
			widgets.get("status").setValue(getStatus());
	}

	public final StringBuilder toString(StringBuilder s)
	{
		return s
			.append(getService())
			.append(",p=").append(getPeople())
			.append(",d=").append(getDiners())
			.append(",s=").append(getSeats())
			.append(",st=").append(getSeatType())
			.append(",t=").append(getTaxi())
			.append(",tx=").append(getTxId())
			.append(",txs=").append(getStatus());
	}
}
