/*
 * JBoss, Home of Professional Open Source
 * Copyright 2009, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2009
 * @author JBoss Inc.
 */
package org.jboss.jbossts.rts.demo.client.service;

import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.Button;


public class Restaurant extends ServicePanel
{
	static private String[] diners = {"0","1","2","3","4","5","6","7","8","9"};

	public Restaurant(String serviceUrl, final StatusPanel summary)
	{
		super("Restaurant", "Restuarant Service - Booking Form", serviceUrl, summary);

		ListBox dinersLb = createListBox(true, "dropdown", 2, diners);

		add(new Label("Table for"));
		add(dinersLb);
		add(new Label("people"));
		fini();

		addWidgetBinding("status", new WidgetBinding("Unknown") {
			public void onSuccess(String value) {summary.updateRestaurantStatus(value);}
		});
		addWidgetBinding("people", new ListBoxWidgetBinding(dinersLb, 2) {
			public void onSuccess(String value) {summary.updateRestaurant(Integer.valueOf(value));}
		}); 
	}
}
