/*
 * JBoss, Home of Professional Open Source
 * Copyright 2009, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2009
 * @author JBoss Inc.
 */
package org.jboss.jbossts.rts.demo.server;

import org.jboss.jbossts.rts.demo.client.TxService;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import java.io.IOException;

public class TxServiceImpl extends RemoteServiceServlet implements TxService
{
    public String startTx(String msg)
    {
        try
        {
            System.out.println("TxServiceImpl.startTx " + msg);
            return TxHelper.startTx(0, false);
        }
        catch (IOException e)
        {
            e.printStackTrace();
            return "Error: " + e.getMessage();
        }
        catch (Throwable e)
        {
            e.printStackTrace();
            return "Error: " + e.getMessage();
        }
    }

    public String endTx(String tx, String fault)
    {
        try
        {
            System.out.println("TxServiceImpl.endTx: " + tx + " arg: " + fault);
            TxHelper.commitTx(tx, false, fault);
            return "commit ok";
        }
        catch (Throwable e)
        {
            e.printStackTrace();
            return "Error: " + e.getMessage();
        }
    }

    public String rollbackTx(String tx, String fault)
    {
        try
        {
            System.out.println("TxServiceImpl.endTx: " + tx + " arg: " + fault);
            TxHelper.rollbackTx(tx, false, fault);
            return "rollback ok";
        }
        catch (Throwable e)
        {
            e.printStackTrace();
            return "Error: " + e.getMessage();
        }
    }
}
