/*
 * JBoss, Home of Professional Open Source
 * Copyright 2008, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2008
 * @author JBoss Inc.
 */
package org.jboss.jbossts.rts.client;

import org.jboss.resteasy.util.HttpResponseCodes;
import org.jboss.jbossts.rts.util.TxUtil;
import org.apache.log4j.Logger;

import java.io.IOException;

/**
 * Basic remote test. @see org.jboss.jbossts.rts.test.AppTest for more tests
 */
public class TxTest
{
    protected final static Logger log = Logger.getLogger(TxTest.class);

    public static void main(String[] args) throws IOException
    {
        log.info("Base URI: " + TxUtil.getBaseURI());
        String query = "clientId=12345&timeout=0";
        String participant = TxUtil.getBaseURI() + "participant/work/pid1";
        // start a transaction
        String tx = TxUtil.doPost(new int[] {HttpResponseCodes.SC_CREATED}, TxUtil.txURI + "/begin?" + query);

        // modify a resource (the example participant has been written such taht is will enlist itself with the transaction
        TxUtil.doPost(new int[] {HttpResponseCodes.SC_OK}, participant,
                "name=p1", "value=v1", "context=" + tx);

        // commit the changes
        TxUtil.doPut(new int[] {HttpResponseCodes.SC_OK}, tx + "/commit", "", "fault=none");
    }
}
