package org.jboss.jbossts.rts.service;

import javax.ws.rs.*;
import javax.ws.rs.core.Response;/*
 * JBoss, Home of Professional Open Source
 * Copyright 2008, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2008
 * @author JBoss Inc.
 */

/**
 * Not used. This interface shows the methods that a participant must implement.
 * However the methods constrain the form that a participant url must take and
 * is therefore inappropriate (since they ought to be unconstrained).
 */
public interface TransactionalParticipant
{
    @GET
    @Path("{pId}/tx/{tid}")
    Response getStatus(@PathParam("pId")String pid, @QueryParam("context") String ctx, @PathParam("status") String status);

    @POST
    @Path("{pId}/tx/{tid}/prepare/")
    Response prepare(@PathParam("pId")String pid, @PathParam("tid")String tid);

    @POST
    @Path("{pId}/tx/{tid}/commit/")
    Response commit(@PathParam("pId")String pid, @PathParam("tid")String tid);

    @POST
    @Path("{pId}/tx/{tid}/rollback/")
    Response rollback(@PathParam("pId")String pid, @PathParam("tid")String tid);

    @POST
    @Path("{pId}/tx/{tid}/forget/")
    Response forget(@PathParam("pId")String pid, @PathParam("tid")String tid);    

// don't forget about one phase commit
}
